Package: Clomial
Type: Package
Title: Infers clonal composition of a tumor
Version: 1.49.0
Date: 2018-05-31
Author: Habil Zare and Alex Hu
Maintainer: Habil Zare <zare@u.washington.edu>
Depends: R (>= 2.10), matrixStats
Imports: methods, permute
Description: Clomial fits binomial distributions to counts obtained
        from Next Gen Sequencing data of multiple samples of the same
        tumor. The trained parameters can be interpreted to infer the
        clonal structure of the tumor.
License: GPL (>= 2)
biocViews: Genetics, GeneticVariability, Sequencing, Clustering,
        MultipleComparison, Bayesian, DNASeq, ExomeSeq,
        TargetedResequencing, ImmunoOncology
LazyLoad: yes
git_url: https://git.bioconductor.org/packages/Clomial
git_branch: devel
git_last_commit: ca3ec4d
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:52:14 UTC; biocbuild

Clomial.iterate <-
function(Dt, Dc, Mu, P, maxIt=100, U=NULL, PTrue=NULL, 
                            llCutoff=10^(-3),
                            computePFunction=compute.P.reparam,
                            doSilentOptim=TRUE,
                            doTalk=TRUE,doLog=TRUE,debug=FALSE,
                            noiseReductionRate=0.01,
                            fliProb=0.05,
                            conservative=TRUE){
  ## TODO: Add a flag such that if U and PTrue are present, 
  ## then Clomial.reorder() function (to be written)
  ## will be called and the error for each iteration
  ## is computed. 
  ## Iterates over EM.
  ## Returns a record of Mus and Ps for every iteration, the final Mu and P,
  ## and the likelihood after each iteration
  ## maxIt: maximum number of iterations allowed before returning the results
  ## Dc: matrix of coverage
  ## Dt: matrix of mutated allele counts
  ## Mu, P: initialized parameter matrices to start iterating on
  ## U, PTrue: True values for matrices. They're not even used by this function.
  ##^ Used for debugging purposes. 
  ## noiseReductionRate: The value which will be deduced from the noise
  ## in each iteration
  ## fliProb: The initial value for the noise which will affect Mu by
  ## flipping some bits randomly, i.e., 1-Mu_{i,j}.
  ##^ Set to 0 to disable  
  ## conservative: Injects the noise only if the likelihood improves after
  ## an iteration.
  if(maxIt<3){
    stop("It is recommended to have at least 3 iterations (maxIt>2) !")
  }
  N <- nrow(Mu)
  C <- ncol(Mu)
  S <- ncol(P)
  startTime <- Sys.time()
  if(is.infinite(noiseReductionRate)){
    fliProb <- 0
  }
  ##
  ## d2b is a list indexed by a decimal value whose element is
  ## the binary representation of that decimal value with length C.
  d2b <- list()
  for(i in 1:2^C){
    d2b[[i]] <- decimal2binary(i, C)
  }
  ##
  ## A state of z is a binary vector of length C that could be a row of Z.
  ## ustates[c] is a list of size 2^(C-1) of decimal representations of 
  ## the states of z where zc = 1. There are C such lists in ustates.
  ustates <- compute.unity.states(C)
  ##
  k <- 1 ## number of iterations
  log.likelihoods <- c(-Inf)
  mus <- list()
  mus[["1"]] <- Mu
  ps <- list()
  ps[["1"]] <- P
  qs <- list()
  while(k < maxIt){
    if(doTalk){
      print(paste("Iteration:",k))
      print(paste("Flipping probability:",fliProb))
    }
    ## Add noise?
    MuNoisy <- Mu
    if(fliProb > 0){
      flips <- sample(x=0:1,size=length(Mu),replace=TRUE,
                      prob=c(1-fliProb,fliProb))
      MuNoisy <- (flips)*(1-Mu)+(1-flips)*Mu
      ## No row of all 0s,
      rows0 <- rowSums(MuNoisy[,-1])==0
      MuNoisy[rows0,] <- Mu[rows0,] ## Don't change these rows
      MuNoisy[,1] <- Mu[,1] ## Don't change the first column
      ## Update noise:
      fliProb <- max((fliProb-noiseReductionRate),0)
    }
    ##
    computedQ <- compute.q(Dc,Dt,Mu,P,doLog=doLog)
    computedQNoisy <- compute.q(Dc,Dt,MuNoisy,P,doLog=doLog)
    if(debug){
      print("P");print(P)
      print("Mu");print(Mu)
      print("computedQ:");print(computedQ)
    }
    Mu <- compute.mu(computedQ$normalizedUnLog,ustates,N,C)
    MuNoisy <- compute.mu(computedQNoisy$normalizedUnLog,ustates,N,C)
    if(debug)
      print(Mu)
    ##Q=exp(qu)
    computedQ <- compute.q(Dc,Dt,Mu,P,doLog=doLog)
    computedQNoisy <- compute.q(Dc,Dt,MuNoisy,P,doLog=doLog)
    ##^ extra qu update.
    P <- computePFunction(C=C,S=S,N=N,Dt=Dt,Dc=Dc,ustates=ustates,
                          qu=computedQ$normalizedUnLog,
                          d2b=d2b,P=P,Mu=Mu,PTrue=PTrue,U=U,debug=debug,
                          doSilentOptim=doSilentOptim,doTalk=doTalk)$optimumP
    PNoisy <- computePFunction(C=C,S=S,N=N,Dt=Dt,Dc=Dc,ustates=ustates,
                               qu=computedQNoisy$normalizedUnLog,
                               d2b=d2b,P=P,Mu=MuNoisy,PTrue=PTrue,U=U,
                               debug=debug,
                               doSilentOptim=doSilentOptim,
                               doTalk=doTalk)$optimumP
    ##
    ll <- Clomial.likelihood(Dc, Dt, Mu, P)$ll
    llNoisy <- Clomial.likelihood(Dc, Dt, MuNoisy, PNoisy)$ll
    ## Add noise only if is beneficial.
    if( llNoisy>(ll+llCutoff) | !conservative){
      if(doTalk)
        print(paste("Noise was applied; from:",ll,"to:",llNoisy))
      Mu <- MuNoisy
      P <- PNoisy
      ll <- llNoisy
    }
    log.likelihoods[k] <- ll
    if(debug){
      print(k); print(log.likelihoods[k])
    }
    ##
    ## Check for convergence		
    if( k > 1 ){
      ## Do at least two iterations before stopping
      likelihood.ratio <- abs((log.likelihoods[k] - log.likelihoods[k-1])
                              /log.likelihoods[k-1])
      if(doTalk)
        print(paste("LL ratio:",likelihood.ratio))
      ##
      if( log.likelihoods[k-1] != -Inf & likelihood.ratio < llCutoff ){
        break
      } 
    }
    k <- k+1
    if(debug)
      print(log.likelihoods)
    ##    
  }##End while(k < maxIt).
  ##
  endTime <- Sys.time()
  output <- list()
  output[["Qs"]] <- qs  #### history of qs
  output[["Ps"]] <- ps  #### history of ps
  output[["Mus"]] <- mus #### history of Mus
  output[["Mu"]] <- Mu ####optimized Mu (not reordered)
  output[["P"]] <- P #### optmized P (not reordered)
  output[["llCutoff"]] <- llCutoff
  output[["maxIt"]] <- maxIt
  output[["LRatio"]] <- likelihood.ratio
  output[["Likelihoods"]] <- log.likelihoods
  output[["fliProb"]] <- fliProb
  output[["endTime"]] <- endTime
  output[["timeTaken"]] <- endTime-startTime
  return(output)
}

compute.mu <-
function( qu, ustates, N, C ){
  ## Returns the updated NxC mu matrix
  ## Each (i,c) element is the sum of all qu[i,'z'] such that zc == 1.
  ##
  mu <- matrix(0,N,C)
  rownames(mu) <- rownames(qu)
  for(c in 1:C){
    for(i in 1:N){
      for(z in 1:length( ustates[[c]] )){
        mu[i,c] <- mu[i,c] + qu[i, ustates[[c]][[z]] ]
      }		
    }		
  }
  mu[,1] <- matrix(0,N,1)
  colnames(mu) <- paste("C",1:C,sep="")
  return(mu)
}

compute.unity.states <-
function(C){
  ## Returns a list of lists of the binary states of z
  ## where zc = 1 for each c in C.
  ## answer[c] will be a list of size 2^(C-1) of
  ## decimal representations of the states of z.
  ## This simplifies the computation of new Mus 
  answer <- list()
  for(i in 1:C){
    answer[[i]] <- list()	
  }
  for(state in 1:(2^C)){
    z <- decimal2binary(state,C)
    for(j in 1:C){
      if(z[j] == 1){
        answer[[j]][[ length(answer[[j]])+1 ]] <- state			
      }
    }
  }
  return(answer)
}

decimal2binary <-
function(n, digits){
    ## Returns a 1 by C matrix that is the binary representation of n-1.
    ## For n> 2^C, we are looking at the remainder of n by 2^C.
    ## Example: (n=10, C=3) =>  10 -> 2 -> 1 -> 001
    ## Maybe could be optimized but not needed for our code.
  n <- n-1
  answer <- matrix(0,1,digits)
  for( i in 1:digits ){
    if( n %% (2^i) != 0 ){
      answer[i] <- 1
      n <- n-(2^(i-1))
    }
  }
  return( rev(answer) )
}

protect.P <-
function(P,maxNormal=0.9){
    ## Makes sure that each column of P (except the P[,1])
    ## has no more than maxNormal in the first row.
    result <- list()
    P2 <- P
    for(J in 2:ncol(P))
      if(P[1,J]>maxNormal){ ## This column needs protection.
        P2[,J] <- (1-maxNormal)/(nrow(P)-1)
        P2[1,J] <- maxNormal
      }##End if(P[1,J]>maxNormal).      
    result[["P"]] <- P
    result[["protected"]] <- P2
    return(result)
  }

dPdW <-
function(Wj,cee){
  ## will compute derivative of P with respect to W,
  ## i.e, (1+sum(W)-W)/(1+sum(W))^2
  ## -Wj is a vector (probably of length C-1).
  ## -cpIsc: determines if c'=c or not.
  ## OUTPUT: the vector of gradient.
  ## QC:
  checked <- check.Wj(Wj)
  sigma <- sum(Wj)
  cpIsc <- 0*Wj
  cpIsc[paste("C",cee,sep="")] <- 1
  result <- ((1+sigma)*cpIsc-Wj) / (1+sigma)^2
  return(result)
}

reorder.clones <-
function(U, PTrue, Mu, P, allPermS){
  ## Finds and returns the permutation of Mu that best matches U.
  ## along with the corresponding permutation of P
  perms <- best.match(m1=U,m2=Mu, perms=allPermS)
  reordered <- list()
  reordered[["Mu"]] <- Mu[,perms[[1]]]
  reordered[["P"]] <- P[perms[[1]],]
  return( reordered )
}

normalizeQ <-
function(qu,doLog,doEnforceNormal=TRUE,scalar=50,doNormalize=TRUE){
    ## Normalizes q such that the sum of each row is 1.
    result <- list()
    N <- nrow(qu)
    C <- log(ncol(qu),base=2)
    newQ <- qu
    for( state in 1:(2^C) ){
      for( i in 1:N){
        s <- sum( qu[i,] )
        if( (!doLog & s==0) | (doLog & !is.finite(max(qu[i,]))) ){
          ## All probabilities are 0.
          if(!doEnforceNormal){
            qi <- rep(2^(-C),times=2^C)
          }else{
            ## The second half corresponds to normal and should be 0.
            qi <- rep(2^(-C),times=2^(C-1))*2
            qi <- c(qi,rep(0,times=2^(C-1)))
          }
          if(doLog){
            newQ[i,] <-log(qi)
          }else{
            newQ[i,] <-qi
          }
        }else
          if(doNormalize) { ## There is non-0 probability,
            if(!doLog){
              newQ[i,] <- qu[i,] / s
            }else{
              ## "Computation in log-space":
              ## Let x=c(log(A,B,C,D)),
              ## Ya=log(A/(A+B))=log(1/(A/A+B/A))=-log(A/A+B/A)
              ## B/A=exp(b)/exp(a)=exp(b-a)
              ## => Ya=-log(exp(a-a)+exp(b-a))=-log(sum(exp(x-a)))
              if(doLog){
                for(ind in 1:2^C){
                  if(is.finite(qu[i,ind])){
                    sum1 <- sum(exp((qu[i,]-qu[i,ind])+scalar)/exp(scalar))
                    newQ[i,ind] <- -log(sum1)
                  }else{
                    newQ[i,ind] <- -Inf
                  }
                }
              }
            }
          }
      }##End for(i).
    }##End for (state).
    result[["qu"]] <- newQ
    return(result)
  }

check.Wj <-
function(Wj,doStop=TRUE){
  ## Checks to see if Wj has proper names.
  isBad <- FALSE
  if(is.null(names(Wj))){
    isBad <- TRUE
  } else {
    if(sum(names(Wj)!=paste("C",1:length(Wj)+1,sep=""))!=0)
      isBad <- TRUE
  }
  if(isBad & doStop){
    stop("Wj should be have names C2,C3, etc.")
  } else
    return(!isBad)
}

rsub <-
function(tempFolder="~/temp/", sourceFile,
                 namePrefix=basename(sourceFile),wait=60,
                 arguments=c(), memory="10.0G",jobShare=200,
                 sourceBashrcBy="~/.bashrc all",
                 doSubmit=TRUE,doDeleteTempFile=FALSE,jobName=NULL,
                 ste=NULL,sto=NULL,
                 doTalk=TRUE,doWarn=TRUE){
  ## Submitts a job to the cluster by qsub:
  ## -ste, sto: The files to save standard error, output in.
  startTime <- Sys.time()
  tempFolder <- paste(tempFolder,"/rsub/",basename(sourceFile),"/",sep="")
  dir.create(tempFolder,recursive=TRUE,showWarnings=FALSE)
  argumentsString <- paste(arguments,collapse="_")
  if(is.null(jobName))
    jobName <- paste(namePrefix,argumentsString,sep="_")
  tempFile <- paste(tempFolder,"/",jobName,"_",startTime,"_qsub.sh",sep="")
  tempFile <- gsub(x=tempFile,pattern=" ",replacement="_" )
  tempFile <- gsub(x=tempFile,pattern=":",replacement="-" )
  if(is.null(ste))
    ste <- paste(tempFile,".e",sep="") ## standard error
  if(is.null(sto))
    sto <- paste(tempFile,".o",sep="")
  ##
  args1 <- paste(arguments,collapse=" ")
  system(paste("echo 'source ",sourceBashrcBy," ' > ",tempFile,sep=""))
  system(paste("echo Rscript  ",sourceFile," ",args1 ," >> ",tempFile,sep=""))
  system(paste("chmod 777 ",tempFile))
  ## Making command:
  commanOptins <- paste("qsub -js ",jobShare,
                        " -l mem_free=",memory, " -l h_vmem=",
                        memory," -l mem_requested=", memory,
                        " -l longjob=TRUE -N ",
                        jobName," -e ",ste," -o ",sto,sep="")
  command <- paste(commanOptins," ",tempFile,sep="")
  if(doTalk)
    print(command)
  ##
  if(doSubmit)
    system(command)
  if(wait<1 & doWarn)
    warning("Jobs may overwrite if wait<1 ")
  Sys.sleep(wait) ## Wait between submitting jobs.
  if(doDeleteTempFile)
    system(paste("rm -rf ",tempFile,sep=""))
  return(list(tempFile=tempFile,jobName=jobName,command=command))
}

compute.errors <-
function(Mu,U,P,PTrue){
  ## Finds the permutation of U that best matches Mu and returns the errors of
  ## Mu and P corresponding to that permutation
  ## INPUTS,
  ## P and Mu: inferred.
  ## PTrue and U: the truth.
  ##
  C <- ncol(Mu)
  if(C>7){
    stop("Too many clones to consider all permutations!")
  }
  allPermS <- rbind( 1:C, permute::allPerms(C))
  reordered <- reorder.clones(U=U,PTrue=PTrue,Mu=Mu,P=P, allPermS=allPermS)
  Mu <- reordered[["Mu"]]
  P <- reordered[["P"]]
  ##  
  UError <- sum(abs(Mu-U)) /length(Mu)
  discUError <- sum(abs(round(Mu)-round(U))) /length(Mu)
  PErrorAbsolute <- mean(abs(P-PTrue))
  PErrorRelative <- mean(abs(P-PTrue)/PTrue)
  ##
  errors <- list()
  errors[["UError"]] <- UError
  errors[["discretizedUError"]] <- discUError
  errors[["PErrorAbsolute"]] <- PErrorAbsolute
  errors[["PErrorRelative"]] <- PErrorRelative
  ##
  return(errors)
}

P2W <-
function(Pj){
  ## Computes Vj(Pj)~ Pj/(1-sum(Pj)).
  ## No log due to computational problems such as log(900)=Inf.
  Pj1 <- Pj[2:length(Pj)] ## ignore the first row of P.
  Wj <- Pj1/(1-sum(Pj1))
  return(Wj)
}

compute.P.reparam <-
function(C,S,N,Dt,Dc,ustates,qu,d2b,P,Mu=NULL,doEnforce=TRUE,trace=0,
           doShowRounds=FALSE,debug=FALSE,
           PTrue=NULL, doSilentOptim=TRUE,U=NULL,doDebug=FALSE,
           doTalk=TRUE){
    ## Computes the new P by first reparametrization and then BFGS-B;
    ## as explained in the paper.
    ## Mu and PTrue are included for debugging.  
    result <- list()
    if(is.null(rownames(P)))
      rownames(P) <- paste("C",1:nrow(P),sep="")
    if(is.null(colnames(P)))
      colnames(P) <- paste("S",1:ncol(P),sep="")
    optimumP <- P
    pre <- 0 ## total value of objective function before optimization
    post <- 0 ## after optimization
    bfgsRounds <- 0 ## max number of rounds objective function called by BFGS.
    for(J in 1:ncol(P)){ ## optimize each column (sample) independently.
      if(doDebug)
        message("J:",J)
      Pj <- P[,J]
      Wj <- P2W(Pj)
      checked <- check.Wj(Wj)
      ## The objective function and its gradient:
      ## Goal: maximize Phi.
      objective <- function(W)
        return(-Phi(Xj=Dt[,J],Rj=Dc[,J],Qu=qu,Pj=c(Pj[1],W2P(W))))
      gradient <- function(W)
        return(-dPhidW(Xj=Dt[,J],Rj=Dc[,J],Qu=qu,Wj=W)$dPhidWOut)
      ##
      if(doDebug|debug)
        browser()
      pre <- pre+objective(W=Wj)
      ##print(objective(W=Wj))
      ##
      update.Wj <- function(Wj,doDebug=FALSE){ ## helps in debugging.
        epsilon <- 10^(-7)
        resultPj <- list()
        optimized <- NULL
        ##
        lowers <- rep(epsilon,times=length(Wj))
        ## Optimizing:
        tried <- try(optimized <- optim(par=Wj,fn=objective,gr=gradient,
                                        lower=lowers,
                                        method="L-BFGS-B",
                                        control=list(trace=trace)),
                     silent=doSilentOptim)
        ##
        resultPj[["tried"]] <- tried
        resultPj[["optimized"]] <- optimized
        if(doDebug)
          browser()
        return(resultPj)
      }##End update.Wj <- function.
      ##
      updated <- update.Wj(Wj=Wj,doDebug=FALSE)
      ##^ the function helps in debugging.
      if(class(updated$tried)!="try-error") {
        ## otherwise do not update this column of P.
        rounds <- updated$optimized$counts["function"]
        bfgsRounds <- max(bfgsRounds,rounds)
        if(doShowRounds)
          print(paste("Optimized after rounds of: ",rounds))
        updatedWj <- updated$optimized$par
        optimumPj <- W2P(W=updatedWj)
        optimumPj <- c(1-sum(optimumPj),optimumPj)
        post <- post+objective(W=updatedWj)
        if(sum(optimumPj<0)!=0 & doEnforce) ##QC.
          stop("None appropriate update for P!")
        ##
        ## Updating:
        optimumP[,J] <- optimumPj
        plot.obj <- function(W,ind=1,st=0.01){
          ## plots the objective function by varying W
          ## st: the step
          result <- list()
          xs <- -100:100*st  
          ys <- c()
          one <- rep(0,length(W))
          one[ind] <- 1
          for(x1 in xs)
            ys[as.character(x1)] <- objective(W+one*x1)
          plot(x=xs,y=ys)
          result[["obj"]] <- ys ## the objective values around Wj
        }##End plot.obj <- function.
        if(debug)
          plot.obj(W=updatedWj)
      }
    }##End for(J in 1:ncol(P)).
    ##
    if(doTalk)
      print(paste(pre," -> ",post, ", ",round(100*(pre-post)/post,2),"%",
                  sep=""))
    optimumP <- protect.P(P=optimumP)$protected
    result[["P"]] <- P
    result[["post"]] <- post
    result[["pre"]] <- pre
    result[["optimumP"]] <- optimumP
    result[["bfgsRounds"]] <- bfgsRounds
    return(result)
  }

compute.q <-
function(Dc,Dt,Mu,P,doEnforceNormal=TRUE,doLog=TRUE){
  ## FIXME, optimization: pass d2b and avoid calling decimal2binary function
  ## Returns an Nx(2^C) matrix
  ## where each element is the Pr(Di,z|P,mu) for a particular i and z.
  ## Pr(Di,z|P,mu) = Pr(Di|z,P) * Pr(z|P,mu)
  ## Each column represents the binary string, translated into decimal,
  ## that represents a particular state of zi.
  result <- list()
  N <- nrow(Dc)
  C <- nrow(P)
  rowDataLikelihoods <- matrix(0,N,2^C)
  rowDataLogLikelihoods <- matrix(0,N,2^C)
  row.z.likelihoods <- matrix(0,N,2^C)
  qu <- matrix(0,N,2^C)
  rownames(qu) <- rownames(Dc)
  if(sum(Mu[,1])!=0 & doEnforceNormal)
    stop("The first column of Mu, corresponding to normal, is not all 0s.")
  ##
  for(i in 1:N){
    for(state in 1:(2^C)){
      z <- decimal2binary(state,C)
      ## p <- z%*%P
      ## p is \pi in the paper.
      p <- (z/2)%*%P ## /2 because of heterozygosity
      p[p>1] <- 1
      ## Pr(X.i|Z.i,P,mu) given by product of binomials
      ##
      rowDataLikelihoods[i,state] <- prod(dbinom(Dt[i,],Dc[i,],p))
      rowDataLogLikelihoods[i,state] <- sum(dbinom(Dt[i,],Dc[i,],p,log=TRUE))
      if(is.nan(rowDataLikelihoods[i,state])){
        warning("NaN!!!!!! rowDataLikelihoods[i,state]")
      }
      if(is.nan(rowDataLogLikelihoods[i,state])){
        warning("NaN!!!!!! rowDataLogLikelihoods[i,state]")
      }
      ## compute the product of Bernoulli distributions needed for 
      ## Pr(Z.i|mu)
      row.z.likelihoods[i,state] <- row.z.likelihood( z, Mu[i,] )
      if(doLog){
        qu[i,state] <- rowDataLogLikelihoods[i,state]+
          log(row.z.likelihoods[i,state])
      } else {
        qu[i,state] <- rowDataLikelihoods[i,state]*row.z.likelihoods[i,state]
      }
    }
  }
  result[["unNormalized"]] <- qu
  ##
  ##Normalizing:
  result[["normalized"]] <- normalizeQ(qu=qu, doLog=doLog,
                                       doEnforceNormal=doEnforceNormal)$qu
  normalizedUnLog <- result[["normalized"]]
  if(doLog)
    normalizedUnLog <- exp(normalizedUnLog)
  result[["normalizedUnLog"]] <- normalizedUnLog
  return(result)
}

Clomial.generate.data <-
function(N, C, S, averageCoverage, mutFraction,doSample1Normal=FALSE, erroRate=0, doCheckDc=TRUE){
    ##
    ## doCheckDc: If TRUE, generating with be repeated until no row of Dc is all zeros
    ##^I.e. all loci should have positive coverage in at least one sample.
    ## QC:
  if(erroRate<0 | 1<erroRate )
    stop("erroRate is the probability of effective sequencing error,
 and should be in range [0,1]!")
  ## Randomly assign N*S*averageCoverage reads to each locus and sample
  Dc <- matrix(0,N,S)
  while(TRUE){
      rnums <- floor( runif( averageCoverage*N*S )*N*S )
      for( i in rnums ){
          Dc[i+1] <- Dc[i+1]+1
      }
      if(sum(rowSums(Dc)==0)==0 | !doCheckDc)
          break
  }
  ##
  ## Generate U such that the first column is 0s 
  ## and the other elements have a probability of mutFraction to be 1
  U <- matrix(runif(N*(C-1)),N,C-1) ## True genotypes of clones
  U[U<mutFraction] <- 1
  U[U != 1] <- 0
  U <- cbind( matrix(0,N,1), U ) ## the first column of U is 0s.
  ## Check to see that at least one clone for each locus contains 
	## a cancer allele. If not, re-assign values at that locus.
  for( i in 1:nrow(U) ){
    while( sum( U[i,] ) == 0 ){
      Ui <- matrix(runif(C-1),1,C-1)
      Ui[ Ui<mutFraction ] <- 1
      Ui[ Ui != 1 ] <- 0
      Ui <- cbind( 0, Ui )
      U[i,] <- Ui
    }
  }
  ##
  ## Generate P such that each column is a normalized vector of uniform draws
  PTrue <- matrix(runif(C*S),C,S)
  for( t in 1:S ){
    PTrue[,t] <- PTrue[,t]/sum(PTrue[,t]) ## normalizing the column.
  }
  if(doSample1Normal)
    PTrue[,1] <- c(1,rep(0,times=C-1))
  ##
  ## No sample can be too close to normal.
  P <- protect.P(P=PTrue)$protected
  ##
  ## Dt is the expected value of the binary distribution given U*P and Dc
  ##
  Phi <- (U/2)%*%PTrue ## /2 because of heterozygosity 
  Dt <- floor(Dc * Phi) ## Only initiates Dt.
  ##
  ## Dt is random samples of the binary distribution given U*P and Dc
  if(TRUE ){
    for( i in 1:N ){
      for( t in 1:S ){
        noisyPhi <- Phi[i,t]*(1-2*erroRate) + erroRate
        ##^ phi*(1-e)+(1-phi)*e
        Dt[i,t] <- rbinom(1,Dc[i,t],noisyPhi)
      }
    }
  }
  if(doSample1Normal)
    Dt[,1] <- 0 ## The first sample is normal.
  ##
  data <- list()
  data[["Dc"]] <- Dc
  data[["Dt"]] <- Dt
  data[["U"]] <- U
  data[["PTrue"]] <- PTrue
  data[["Likelihood"]] <- Clomial.likelihood(Dc,Dt,U,PTrue)$ll
  data[["Phi"]] <- Phi
  ##
  return(data)
}

dPhidPcp <-
function(Xj,Rj,Qu,Pj,cp,doDebug=FALSE){
  ## will compute partial derivative of Phi with respect to P_{c',j}.
  ## -Pj is the j'th column of P with length C.
  ## -Muc is the c'th column of Mu.
  ## -cp: c', the index for Z_{i,c'}. See supplement.pdf.
  C <- length(Pj)
  derivative <- 0
  for( state in 2:(2^C) ){ ## for all possible values of a row of Z, expect 0s.
    zee <- decimal2binary(state,C) ## binary representation of state-1
    if(zee[cp]==0)
      next ## 0*x=0
    piBinom <- (zee/2)%*%Pj ## /2 because of heterozygosity,
    ## Note: maybe derivative is twice more or less, but in the same direction.
    piBinom[piBinom>1] <- 1
    XOverpiFraction <- Xj/piBinom
    RXOverpiFraction <- (Rj-Xj)/(1-piBinom)
    fraction <- XOverpiFraction-RXOverpiFraction
    derivBinom <- Qu[,state]*fraction
    summand <- sum(derivBinom) ## sum over i 
    ##
    if(!is.nan(summand))
      derivative <- derivative + 1*summand ## zee[cp]=1
    if(doDebug)
      browser()
  }
  derivative <- derivative /2  ## /2 because of heterozygosity
  result <- derivative 
  return(result)
}

dPhidW <-
function(Xj,Rj,Qu,Wj,doDebug=FALSE){
  ## will compute derivative of Phi with respect to W
  ## by chain rule: sum_{c'} (dPhidPcp*dPdW)
  result <- list()
  checked <- check.Wj(Wj)
  pj <- W2P(Wj) ##Pj without the first entry associated with normal sample.
  C <- length(pj)+1
  if(length(pj)!=length(Wj))##QC,
    stop("Length of Wj should be less than length of Pj!")
  if(C<2)
    stop("Too small C (clone number)!")
  ##
  gradient <- c()
  d1 <- c()
  d2 <- list()
  ## for improvement in efficiency by moving d1 & d2 out of loops
  for(cp in 2:C){
    d1[cp] <- dPhidPcp(Xj=Xj,Rj=Rj,Qu=Qu,Pj=c(0.5,pj),cp=cp)
    ##^ The first entry of Pj doesn't contribute.
  }
  for(cee in 2:C){
    d2[[cee]] <- dPdW(Wj=Wj,cee=cee)
  }
  for(cee in 2:C){
    ceeChar <- as.character(cee)
    gradient[ceeChar] <- 0
    for(cp in 2:C){
      ##^ -cp: c', the index for Z_{i,c'}. See the paper.
      gradient[ceeChar] <- gradient[ceeChar] +
        d1[cp]*(d2[[cee]][paste("C",cp,sep="")])
      if(doDebug)
        browser()
    }
  }
  ##
  result[["pj"]] <- pj ## of length 1 LESS than Pj.
  ##QC:
  if(length(gradient)!=length(Wj))
    stop("The length of gradient should be the same as input Wj!")
  result[["dPhidWOut"]] <- gradient
  return(result)
}

Clomial <-
function(Dt=NULL,Dc=NULL,DcDtFile=NULL,
                    C,doParal=FALSE,outPrefix=NULL,
                    binomTryNum=1000,maxIt=100,llCutoff=0.001,
                    jobNamePrefix="Bi",qstatWait=2,fitBinomJobFile=NULL,
                    jobShare=10,
                    ignoredSample=c(),
                    fliProb=0.05,conservative=TRUE, doTalk=FALSE){
  ## Runs many iterations to fit a binomial model to the data.
  ## It prepares the initializations and fits many models.
  ## -ignoredSample: The column index to be ignored.
  result <- list()
  binomTries <- list() ##The results of EM iterations to fit the binomials.
  ## qstat commands:
  qstatWaitCom <- paste("qstat |grep ",jobNamePrefix,"|grep qw|wc -l",sep="")
  qstatAll <- paste("qstat |grep ",jobNamePrefix,"|wc -l",sep="")
  ## Input check:
  if(is.null(Dt)|is.null(Dc)){ ## We expect to read it from file.
    if(is.null(DcDtFile))
      stop("Where should I read the counts from?")
    if(!file.exists(DcDtFile))
      stop(paste("No data file at:",DcDtFile))
    load(DcDtFile) ## Dt and Dc are loaded.
  }

  ## Ignoring some samples?
  if(length(ignoredSample)>0){
    if(doTalk)
      print(paste("These samples will be ignored:",ignoredSample))
    Dc <- Dc[,-ignoredSample]; Dt <- Dt[,-ignoredSample]
  }

  Dc <- as.matrix(Dc)
  Dt <- as.matrix(Dt)
  N <- nrow(Dc)
  S <- ncol(Dc)
  ## QC,
  if( (nrow(Dt)!=N) | (ncol(Dt)!=S) )
    stop("Dc and Dt should have the same dimension!")
  if( S<2 ){
    m1 <- "At least 2 samples are needed to run Clomial!"
    m2 <- "A normal sample can be simulated by adding"
    m3 <- "a column of 1s and 0s to Dc and Dt, accordingly."
   stop(paste(m1,m2,m3))
  }
  if(maxIt<3){
    stop("It is recommended to have at least 3 iterations (maxIt>2) !")
  }
  ##
  freq1 <- Dt/Dc
  if(0 %in% rowSums(Dc)){
      stop("Some rows of Dc are zero!")
  }
  for(J in 1:binomTryNum){
    if(doTalk)
      print(paste("--- Training the ",J,"th model...",sep=""))
    if(!doParal){
      ## Random initialization:
      random1 <- runif(n=N*(C-1),min=rowMins(freq1,na.rm=TRUE)*0.9,max=rowMaxs(freq1,na.rm=TRUE)*1.1)
      random1[random1>1] <- 1
      random1[random1<0] <- 0
      Mu <- matrix(random1,N,C-1)
      Mu <- cbind( matrix(0,N,1), Mu )
      rownames(Mu) <- rownames(Dc)
      colnames(Mu) <- paste("C",1:C,sep="")
      P <- matrix(runif(C*S),C,S)
      rownames(P) <- colnames(Mu)
      colnames(P) <- colnames(Dc)
      ## Normalize P:
      for( t in 1:S ){
        s <- sum(P[,t])
        P[,t] <- P[,t]/s
      }##End for.
      ##
      binomTries[[J]] <- try(Clomial.iterate(maxIt=maxIt, Dc=Dc, Dt=Dt,
                                             Mu=Mu, P=P,
                                             doSilentOptim=FALSE,
                                             llCutoff=llCutoff,
                                             computePFunction=compute.P.reparam,
                                             doTalk=doTalk,
                                             fliProb=fliProb,
                                             conservative=conservative))
    } else { ## Submit jobs to cluster
      dir.create(outPrefix,showWarnings=FALSE)
      tryName <- paste(jobNamePrefix,J,sep="")
      outPrefixJ <- paste(outPrefix,"/",tryName,sep="")
      while(TRUE){
        doSubmitNow <- TRUE
        if((J%%100)==0){
          totalJobsNum <- system(qstatAll,intern=TRUE)
          totalJobsNum <- as.numeric(totalJobsNum)
          waitingJobsNum <- system(qstatWaitCom,intern=TRUE)
          waitingJobsNum <- as.numeric(waitingJobsNum)
          if(waitingJobsNum > (1/2)*totalJobsNum+200){
            ## wait for some jobs to finish.
            doSubmitNow <- FALSE
            Sys.sleep(qstatWait)            
          }
        }
        if(doSubmitNow){
          print(J)
          args1 <- c(DcDtFile,0,C,llCutoff,outPrefixJ,fliProb,ignoredSample)
          s1 <- rsub(tempFolder=outPrefix,sourceFile=fitBinomJobFile,
                     namePrefix=tryName,wait=0.1,
                     arguments=args1,
                     memory="1.0G",jobShare=jobShare,
                     doSubmit=TRUE,doDeleteTempFile=FALSE,jobName=tryName,
                     ste=NULL,sto=NULL,
                     doTalk=FALSE,doWarn=FALSE)
          print(J)
          break 
        }
      }
    }## End else, a job was submitted.
  }##End for(J in 1:binomTryNum).
  if(doParal){
    ## These are the files where the outputs were saved in.
    binomTries <- paste(outPrefix,"/",jobNamePrefix,1:binomTryNum,".RData",
                        sep="")
  }
  if(!is.null(outPrefix)){
    save(binomTries,file=paste(outPrefix,".RData",sep=""))
  }
  result[["models"]] <- binomTries
  return(result)
}

Clomial.likelihood <-
function(Dc, Dt, Mu, P){
  ## Sums log-likelihoods assuming a binomial distribution for each Dt_[i,t]
  ## Where n = Dc_[i,t], k = Dt_[i,t], and p =  Mu_i*P[,t] 
  ## OUTPUT: ll is the log-likelihood, and llS is the matrix for all mutations
  ## and clones.
  result <- list()
  log.likelihood <- 0
  llS <- c()
  ##
  for(i in 1:nrow(Mu)){
    ##p <- Mu[i,]%*%P
    p <- (Mu[i,]/2)%*%P ## /2 because of heterozygosity
    p[p>1] <- 1
    ##
    lli <- dbinom(Dt[i,],Dc[i,],p,log=TRUE)
    log.likelihood <- log.likelihood + sum(lli)
    llS <- rbind(llS,lli)
  }
  rownames(llS) <- rownames(Mu)
  result[["ll"]] <- log.likelihood
  result[["llS"]] <- llS
  return(result)
}

best.match <-
function(m1, m2, perms){
  ## Matches the columns of row m2 to the columns of m1. 
  ## Values should be all positive or all negative.
  ## Returns a list containing 
  ## [1] the ordering of the cols of m2 that corresponds to m1
  ## [2] the absolute-valued difference between the matched m1 and m2
  ## Brute force approach
  products <- t(m1)%*%(m2) 
  maxPerm <- -1
  maxSum <- 0
  for(p in 1:nrow(perms)){
    s <- 0
    for(i in 1:nrow(products)){
      s <- s+products[i,perms[p,i]]
    }
    if(s > maxSum){
      maxSum <- s
      maxPerm <- p
    }
  }
  if(maxPerm == -1){
    warning("best_match failed!")
  }
  return(list(perms[maxPerm,], sum(abs(m1 - m2[,perms[maxPerm,]]))))
}

choose.best <-
function(models,U=NULL,PTrue=NULL,compareTo=NULL,upto="All", doTalk=FALSE){
  ## Chooses the best iteration out of the set
  ## -compareTo: The try with which each try is compared.
  ## are considered and P will be updated accordingly.
  ## The pruned model with the best likelihood
  ## will be returned. I need to write prune.genotype() function to do this.
  ## which make phyl tree
  ## and returned the one with the best likelihood.
  ## -models can be a list of outputs produced by iterate(), 
	## or it can be a vector of characters
  ## each of which pointing to a file containing the output for a random seed.
  ## 
  maxLikelihood <- -Inf
  bestIndex <- 1
  bestModel <- "none"
  model <- NULL ## Will be loaded.
  ## The error when truth is known.
  err <- list();err[["U"]] <- c();err[["P"]] <- c()
  ## The difference between a try and the best one.
  diffBest <- list(); diffBest[["U"]] <- c(); diffBest[["P"]] <- c()
  diffBest[["discretizedU"]] <- c();
  Li <- c()
  seconds <- c()
  if(upto=="All"){
    inds <- 1:length(models)
  }else{
    inds <- 1:upto
  }
  if(doTalk)
    print(paste("Choosing the best out of",length(inds),"..."))
  for( JInd in inds){
    J <- as.character(JInd)
    if(JInd %% 1000==0 & doTalk)
      print(JInd)
    Li[J] <- NA
    seconds[J] <- NA
    err[["U"]][J] <- NA
    err[["P"]][J] <- NA
    if(class(models)=="list"){
      outI <- models[[JInd]]
    }else{ ## models is the vector of saved results.
      binomTries <- NULL
      load(models[JInd]) ## binomTries is loaded.
      outI <- binomTries[[1]]
    }
    if( class(outI) != "try-error" ){
      LLI <- tail( outI[["Likelihoods"]], n = 1 )
      if( LLI > maxLikelihood ){
        bestIndex <- JInd
        maxLikelihood <- LLI
        bestModel <- outI
      }##End if.
      Li[J] <- LLI
      seconds[J] <- as.numeric(outI$timeTaken, unit="secs") 
      if(!is.null(U) & !is.null(PTrue)){
        computedError <- compute.errors(Mu=outI$Mu,U=U, P=outI$P, PTrue=PTrue)
        err[["U"]][J] <- computedError$UError
        err[["P"]][J] <- computedError$PErrorAbsolute
      }
      ##
      if(!is.null(compareTo)){
        ## How different is each try from the best?
        if(class(models)=="list"){
          compareToTry <- models[[compareTo]]
        } else {
          binomTries <- NULL
          load(models[compareTo]) ## binomTries is loaded.
          compareToTry <- binomTries[[1]]          
        }
        computedDiff <- compute.errors(Mu=outI$Mu,U=compareToTry$Mu,P=outI$P,
                                       PTrue=compareToTry$P)
        diffBest[["U"]][J] <- computedDiff$UError
        diffBest[["discretizedU"]][J] <- computedDiff$discretizedUError
        diffBest[["P"]][J] <- computedDiff$PErrorAbsolute
      }
    }##End if.    
  }##End for.
  result <- list(err=err,Li=Li,bestInd=bestIndex,bestLi=Li[bestIndex],
                 comparison=diffBest,bestModel=bestModel,seconds=seconds)
  return(result)
}

Phi <-
function(Xj,Rj,Qu,Pj,doDebug=FALSE){
  ## will return Expected_Z[log(Pr(X|Z,Pj))]
  ## -Rj will be Dc[,j].
  ## -Xj will be Dt[,j].
  result <- 0
  C <- length(Pj)
  if(ncol(Qu)!=2^C)
    stop("Not compatible inputs!")
  for( state in 2:(2^C) ){ ## for all possible values of a row of Z,
    ## state=1 => zee=rep(0) => Pr=0 => safe to ignore
    zee <- decimal2binary(state,C) ## binary representation of state-1
    piBinom <- (zee/2)%*%Pj ## /2 because of heterozygosity
    piBinom[piBinom>1] <- 1
    summand <- dbinom(Xj,Rj,piBinom,log=TRUE) ## it's a vector
    s1 <- summand
    if(doDebug)
      browser()
    ##summand <- summand+ Xj*log(piBinom)
    ##summand <- summand+ (Rj-Xj)*log(1-piBinom)
    summand <- Qu[,state]*summand
    summand[Qu[,state]==0] <- 0 ## NaN happens when Qu=piBinom=0.
    summand <- sum(summand)
    result <- result + summand
  }
  return(result)
}

compute.bic <-
function( Dc, Dt, Mu, P){
  ## Computes the BIC using:
  ## BIC = NC log(obsNum) - 2 log(L)
  ## Where n = Dc_[i,t], k = Dt_[i,t], p = and Mu_i *P[,t] 
  ## L = log-likelihood
  result <- list()
  ll <- Clomial.likelihood(Dc=Dc, Dt=Dt, Mu=Mu, P=P)$ll
  result[["ll"]] <- ll
  N <- nrow(Mu)
  C <- ncol(Mu)
  M <- ncol(P)
  obsNum <- sum(Dc)
  obsNumAverage <- obsNum/(N*M)
  aic <- -2*ll + (N*C+M*(C-1))*2
  bic <- -2*ll + (N*C+M*(C-1))*log(obsNum)
  ##
  result[["bic"]] <- bic
  result[["aic"]] <- aic
  result[["obsNum"]] <- obsNum
  return(result)
}

row.z.likelihood <-
function(Zi, mu_i){
  ## Product of P(Zi[c]) = mu_i[c] for each Zi[c]
  ## assuming a Bernoulli distribution
  C <- length(Zi)
  answer <- 1
  for(c in 1:C){
    if(Zi[c] == 1){
      answer <- answer * mu_i[c]		
    }	
    else{
      answer <- answer * ( 1-mu_i[c] )		
    }
  }
  return(answer)
}

%
% NOTE -- ONLY EDIT THE .Rnw FILE!!!  The .tex file is
% likely to be overwritten.
%


%\VignetteIndexEntry{A likelihood maximization approach to infer the clonal structure of a cancer using multiple tumor samples}
%\VignetteDepends{Clomial}
%\VignetteKeywords{Cancer, Binomial, Clones, EM}
%\VignettePackage{Clomial}
\documentclass[12pt]{article}

\usepackage{amsmath}
\usepackage{cite, hyperref}

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\refOne}{\textit{Zare et al. 2014}}
\newcommand{\code}[1]{\texttt{#1}}


\author{Habil Zare }

\begin{document}
\title{Clomial: A likelihood maximization approach to infer the 
clonal structure of a cancer using multiple tumor samples}
\maketitle{}

\tableofcontents
\newpage

\section{Introduction}
Identifying the clonal decomposition of a tumor is oncologically important 
and computationally challenging.  

\subsection{Oncological motivation}
Cancers arise from successive rounds of mutation and selection, generating 
clonalpopulations that vary in size, mutational content and 
drug responsiveness.
Ascertaining the clonal composition of a tumor is therefore important both 
for prognosis and therapy. Mutation counts
and frequencies resulting from next-generation sequencing (NGS) potentially 
reflect a tumor's clonal composition; however, deconvolving NGS data to infer 
a tumor's clonal structure presents a major challenge.

\subsection{Computational methodology}
Clomial is based on a generative model for NGS data derived from multiple 
subsections of a single tumor.
The counts of alternative alleles are modeled using binomial distributions, 
and therefore, the novel method is called {\bf ``Clomial''}; 
{\bf Clo}nal decomposition using bino{\bf{mial}} models.
Unlike the previous approaches, Clomial is capable of incorporating multiple
samples in the analysis together to increase statistical power.
It uses an expectation-maximization (EM) procedure for estimating
the clonal genotypes and relative frequencies
as described in \refOne,
which demonstrates, via simulation,
the validity of Clomial approach.
As a real life example, 
this package also provides the data and code to infer the clonal composition
of a primary breast cancer and associated metastatic lymph node. 
Applying Clomial to larger numbers of tumors should cast light on the 
clonal evolution of cancers in space and time.

Please refer to \refOne for a complete  description of
the methodology, and the results on the real data set.



\section{How to run Clomial?}
\subsection{Installation}
Clomial is an R package source that can be downloaded and 
installed from Bioconductor with the following commands in R:
\newline
$\\$
\texttt{if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")}
\newline
\texttt{BiocManager::install("Clomial")}
$\\$

Alternative, if the source code is already available, 
the package can be installed by the following command in Linux:
\newline
$\\$
\texttt{R CMD INSTALL Clomial\_x.y.z.tar.gz}
\newline
$\\$
where x.y.z. determines the version.
The second approach requires all the dependencies be installed manually, 
therefore, the first approach is preferred.

\subsection{A quick overview}
The main function is \code{Clomial()} which takes as input 2 matrices 
$Dt$ and $Dc$.
They contain the counts of the alternative allele, and the total number of 
processed reads, accordingly. 
Their rows correspond to the genomic loci, and their columns correspond to 
the samples.
Also, $C$, the assumed number of clones should be provided to \code{Clomial()}.
Several models should be trained using different initial values to escape from
 local optima.
Then, the best one in terms of the likelihood can be chosen by 
choose.best() function.
Finally, the Bayesian Information Criterion (BIC) can be performed using the 
compute.bic() function
to estimate the number of clones. However, the results of BIC analysis should 
be interpreted with 
great caution for the reasons explained in \refOne.


\subsection{An example}

This example shows how Clomial can be run on counts obtained from next 
generation sequencing. 
The user might use standard tools such as BWA, Samtools, or DeepSNV to map 
the reads and compute the counts.
In the following example, we analyze ready-to-use data from a primary breast
cancer and associated metastatic lymph node,
where breastCancer is a list containing the input 2 matrices $Dt$ and $Dc$.

\begin{center}
<<example,fig=FALSE, echo=TRUE>>=
library(Clomial)
set.seed(1)
data(breastCancer)
Dc <- breastCancer$Dc
Dt <- breastCancer$Dt
Clomial2 <-Clomial(Dc=Dc,Dt=Dt,maxIt=20,C=4,binomTryNum=2)
@
\end{center}

Clomial is done and the results are stored in \code{Clomial2}. 
We are interested in \code{Clomial[["models"]]} which is a list of 
trained models.
For each trained model, $Mu$ models the matrix of genotypes, 
where rows and columns correspond to genomic loci and clones, accordingly. 
Also, \code{P} is the matrix of clonal frequency where rows and columns 
correspond to clones and samples, accordingly. For example, the trained 
parameters for the first model are given by:

\begin{center}
<<model1,fig=FALSE, echo=TRUE>>=
model1 <- Clomial2$models[[1]]
## The clonal frequencies:
round(model1$P,digits=2)
## Similarly, the genotypes is given by round(model1$Mu).
@
\end{center}

\subsection{Choosing the best model}
In practice, more models should be trained using multiple random 
initialization to escape from local optima. This can be done by,
say, \code{binomTryNum=1000} which needs longer computational time, 
in order of two hours, for this data.
For the purpose of this manual, we can use pre-computed results as follows:

\begin{center}
<<model1,fig=FALSE, echo=TRUE>>=
data(Clomial1000)
models <- Clomial1000$models
## Number of trained models:
length(models)
@
\end{center}

The best model in terms of likelihood is given by \code{choos.best()} function:
\begin{center}
<<model1,fig=FALSE, echo=TRUE>>=
chosen <- choose.best(models=models, doTalk=TRUE)
M1 <- chosen$bestModel
print("Genotypes according to the best model:")
round(M1$Mu)
print("Clone frequencies in the first sample:")
round(M1$P[,1],digits=2)
@
\end{center}

In the above demo example, the number of clones was assumed to be 4. 
For real applications, it is useful to try several clone numbers and 
compare the results using BIC.
Also, note that fitting the best set of parameters needs a large number of 
models to be trained on data
in order to escape from local optima. In practice, the suitable number of 
models depends on the assumed number of clones, number of genomic loci, 
and number on samples.

\section{Reference}
Zare et al., \textbf{
Inferring clonal composition from multiple sections of a breast cancer},
PLoS Comput Biol 10(7): e1003703.


\end{document}

\name{Clomial-package}
\alias{Clomial-package}
\docType{package}
\title{
Fits a binomial model to data from multiple samples of a single tumor to
infer its clonal decomposition.
}
\description{
Clomial fits binomial distributions to counts obtained from Next Gen
Sequencing data of multiple samples of the same tumor. The trained
parameters can be interpreted to infer the clonal structure of the
tumor.
}
\details{
\tabular{ll}{
Package: \tab Clomial\cr
Type: \tab Package\cr
Version: \tab 0.99.0\cr
Date: \tab 2014-02-11\cr
License: \tab GPL (>= 2)\cr
}
The main function is Clomial() which requires 2 matrices Dt and Dc among
its inputs. They contain the counts of the alternative allele, and the
total number of processed reads, accordingly. Their rows correspond to
the genomic loci, and their columns correspond to the samples. Several
models should be trained using different initial values to escape from
local optima, and the best one in terms of the likelihood can be chosen
by choose.best() function.
}
\author{
Habil Zare and Alex Hu

Maintainer: Habil Zare <zare@u.washington.edu>
}
\references{
  Inferring clonal composition from multiple sections of a breast cancer,
  Zare et al., PLoS Computational Biology 10.7 (2014): e1003703.
}
\keyword{ package }
\keyword{ datasets }
\keyword{ iteration }
\keyword{ documentation }
\keyword{ models }

\seealso{
\code{\link{Clomial}}, \code{\link{choose.best}},
\code{\link{Clomial.iterate}},  \code{\link{Clomial.likelihood}},
\code{\link{compute.bic}}, \code{\link{breastCancer}}
}
\examples{
set.seed(1)
data(breastCancer)
Dc <- breastCancer$Dc
Dt <- breastCancer$Dt
ClomialResult <-Clomial(Dc=Dc,Dt=Dt,maxIt=20,C=4,doParal=FALSE,binomTryNum=2)
chosen <- choose.best(models=ClomialResult$models)
M1 <- chosen$bestModel
print("Genotypes:")
print(round(M1$Mu))
print("Clone frequencies:")
print(M1$P)
}

\name{Clomial1000}
\alias{Clomial1000}
\docType{data}
\title{
Pre-computed results of Clomial.}

\description{
Pre-computed results of Clomial function are provided for demo purposes.
It contains 1000 trained models on counts data from multiple samples of
a single primary breast cancer
obtained by deep, next-generation sequencing.}

\usage{data(Clomial1000)}
\format{\code{Clomial1000[["models"]]} is the list of trained models.}

\details{
Each model is the output of \code{Clomial.iterate()} function 
on the \code{breastCancer} data assuming there are 4 clones.}


\references{
  Inferring clonal composition from multiple sections of a breast cancer,
  Zare et al., Submitted.}

\seealso{
\code{\link[Clomial:Clomial-package]{Clomial}},
\code{\link{Clomial.iterate}}, \code{\link{choose.best}},
\code{\link{breastCancer}}
}

\examples{
data(Clomial1000)
chosen <- choose.best(models=Clomial1000$models)
M1 <- chosen$bestModel
print("Genotypes:")
round(M1$Mu)
print("Clone frequencies:")
M1$P
bestInd <- chosen$bestInd
plot(chosen$Li,ylab="Log-likelihood",type="l")
points(x=bestInd,y=chosen$Li[bestInd],col="red",pch=19)
}

\keyword{datasets}

\name{breastCancer}
\alias{breastCancer}
\docType{data}
\title{
Breast cancer data for clonal decomposition.}

\description{
Counts data from multiple samples of a single primary breast cancer obtained by deep, next-generation sequencing. 
The file is consist of two matrices \code{Dt} and \code{Dc} which contain the counts of the alternative alleles, and the total number of counts on each genomic loci for every tumor samples, accordingly.}


\usage{data(breastCancer)}
\format{A list containing 2 matrices.}

\details{
Each matrix contains counts of reads mapped to 17 genomic loci for 12 tumor samples where
the column A5-2 corresponds to the normal sample.
}
%\source{
%%  ~~ reference to a publication or URL from which the data were obtained ~~
%}

\references{
Inferring clonal composition from multiple sections of a breast cancer, Zare et al., Submitted.}

\seealso{
\code{\link[Clomial:Clomial-package]{Clomial}}
}
\examples{
data(breastCancer)
breastCancer$Dt
}
\keyword{datasets}

\name{compute.bic}
\alias{compute.bic}
\title{
	Computes BIC for a Clomial model.
}
\description{
	Computes the Bayesian Information Criterion (BIC) for a Clomial
	model, which might be useful to estimate the number of clones. A
	"significantly" smaller BIC is usually interpreted as a better
	fit to the data.
}
\usage{
	compute.bic(Dc, Dt, Mu, P)
}
\arguments{
 \item{Dt}{
	A matrix which contains the counts of the alternative allele
	where rows correspond to the genomic loci, and columns
	correspond to the samples.
}
 \item{Dc}{
	A matrix which contains the counts of the total number of mapped
	reads where rows correspond to the genomic loci, and columns
	correspond to the samples.
}
  \item{Mu}{
	The matrix which models the genotypes, where rows and columns
	correspond to genomic loci and clones, accordingly.
}
  \item{P}{
	The matrix of clonal frequency where rows and columns correspond
	to clones and samples, accordingly.
}
}

\details{
	The Bayesian Information Criterion (BIC) for a model is computed
	by subtracting the expected log-likelihood times 2, from the
	number of free parameters of the model times logarithm of the
	total number of observations. For a Clomial model, we have
	\code{BIC = (NC+SC-S)log(sum(Dc))-2L}, where \code{L} is the
	likelihood, \code{N} is the number of genomic loci, \code{C} is
	the assumed number of clones, \code{S} is the number of samples,
	and \code{sum(Dc)} is the total number of observed reads.   
}
\value{
A list will be made with the following entries:
	\item{bic }{The BIC value.}
	\item{aic }{The AIC value.}
	\item{obsNum }{The total number of observed reades.}
}
\references{
  Inferring clonal composition from multiple sections of a breast cancer,
  Zare et al., Submitted.
}
\author{
Habil Zare
}
\note{
Theoretically, a method such as the Bayesian information criterion (BIC)
	or the Akaike information criterion (AIC) may be applied to
	estimate the number of clones. However, in practice, the outcome
	of such approaches should be interpreted with great caution
	because some of the underlying assumptions of the statistical
	analysis may not be necessarily true for a given model. For
	example, while a "small" improvement in the BIC is generally
	considered as a sign to stop making the model more complicated,
	making such decisions is very objective, and requires relying on
	thresholds with little statistical basis.
}

\seealso{
\code{\link[Clomial:Clomial-package]{Clomial}}
}
\examples{
set.seed(1)
data(breastCancer)
Dc <- breastCancer$Dc
Dt <- breastCancer$Dt
bics <- c()
Clomial3 <-Clomial(Dc=Dc,Dt=Dt,maxIt=20,C=3,doParal=FALSE,binomTryNum=1)
model3 <- Clomial3$models[[1]]
bics[3] <- compute.bic(Dc=Dc,Dt=Dt, Mu=model3$Mu, P=model3$P)$bic
Clomial4 <-Clomial(Dc=Dc,Dt=Dt,maxIt=20,C=4,doParal=FALSE,binomTryNum=1)
model4 <- Clomial4$models[[1]]
bics[4] <- compute.bic(Dc=Dc,Dt=Dt, Mu=model4$Mu, P=model4$P)$bic
print(bics) ## 4 is a better estimate for the number of clones.
}

\keyword{ documentation }

\name{Clomial}
\alias{Clomial}
\title{
Fits several binomial models to data from multiple samples of a single tumor.
}
\description{
Using EM, trains several models using different initial values to escape
from local optima. The best one in terms of the likelihood can be later
chosen by choose.best() function.
}
\usage{
Clomial(Dt = NULL, Dc = NULL, DcDtFile = NULL, C, doParal=FALSE,
outPrefix = NULL, binomTryNum = 1000, maxIt = 100, llCutoff = 0.001,
jobNamePrefix = "Bi", qstatWait = 2, fitBinomJobFile = NULL,
jobShare = 10, ignoredSample = c(),  fliProb=0.05, conservative=TRUE,
doTalk=FALSE)

}
\arguments{
  \item{Dt}{
	A matrix which contains the counts of the alternative allele
	where rows correspond to the genomic loci, and columns
	correspond to the samples.
}
  \item{Dc}{
	A matrix which contains the counts of the total number of mapped
	reads where rows correspond to the genomic loci, and columns
	correspond to the samples.
}
  \item{DcDtFile}{
	A file from which the data can optionally be loaded. It should
	contain the matrices Dc and Dt.
}
  \item{C}{
	The assumed number of clones.
}
  \item{doParal}{
	Boolean where TRUE means, in Linux, models with different
	initialization are trained in parallel on a cluster using qsub.
}
  \item{outPrefix}{
	A prefix for the path to save the results.
}
  \item{binomTryNum}{
	The number of models trained using different initialization.
}
  \item{maxIt}{
	The maximum number of EM iterations.
}
  \item{llCutoff}{
	EM iterations stops if the relative improvement in the
	log-likelihood is not more than this threshold. 
}
  \item{jobNamePrefix}{
	If run in parallel, this prefix will be used to name the jobs on
	the cluster.
}
  \item{qstatWait}{
	The waiting time between qstat commands to assess the number of
	running and waiting jobs.
}
  \item{fitBinomJobFile}{
	If run in parallel, this is the script which loads data, trains
	a model using a random initialization, and saves the results.
}
  \item{jobShare}{
	If run in parallel, the job_share option of qsub determines the
	priority of jobs over other submitted jobs.
}
  \item{ignoredSample}{
	A vector of indices of samples which will be ignored in
	training. Used by experts only to measure the stability of the
	results.
}
	\item{fliProb}{
	A "flipping probability" used for noise injection which can be
	disabled when \code{fliProb=0}. After the first EM iteration,
	each entry of the matrix \code{Mu} such as \code{m} may change
	to \code{1-m} with this probability. This probability decreases
	on subsequent iterations. 
}
	\item{conservative}{
	Boolean where TRUE means noise will be injected only if
	likelihood is improved after an EM iteration, otherwise the
	original Mu matrix will be used for the next iteration. For
	expert use only.
}
	\item{doTalk}{
	If TRUE, information on the EM optimization iterations is reported.
}
}

\details{
	The likelihood of the model, given the hidden variables and the
	parameters, can be computed based on a combination of binomial
	distributions. In each EM iteration, the likelihood is
	increased, however, due to presence of local optima, several
	models should be tried using different random
	initialization. For higher number of assumed clones, \code{C},
	the parameter binomTryNum should be increased because the
	dimension of the search space grows linearly with \code{C}.
}

\value{
Returns a list containing the entry called \code{models},
which is a list of the length equal to binomTryNum where each element is
a trained model.
For each trained model, \code{Mu} models the matrix of genotypes, where
rows and columns correspond to genomic loci and clones,
accordingly. Also, \code{P} is the matrix of clonal frequency where rows
and columns correspond to clones and samples, accordingly.
The first column of \code{P} corresponds to the normal clone. 
The history of \code{Mu}, \code{P}, and the log-likelihood over
iterations is saved in lists \code{Ps}, \code{Mus}, and
\code{Likelihoods}, accordingly.
}
\references{
  Inferring clonal composition from multiple sections of a breast cancer,
  Zare et al., Submitted.
}
\author{
Habil Zare
}
\note{
	The parallel mode works only in Linux, and when qsub and qstat
	commands are available on a cluster.
}

\seealso{
\code{\link[Clomial:Clomial-package]{Clomial}},
\code{\link{choose.best}}, \code{\link{Clomial.iterate}},
\code{\link{compute.bic}}, \code{\link{breastCancer}}
}
\examples{
set.seed(1)
data(breastCancer)
Dc <- breastCancer$Dc
Dt <- breastCancer$Dt
ClomialResult <-Clomial(Dc=Dc,Dt=Dt,maxIt=20,C=4,binomTryNum=2)
chosen <- choose.best(models=ClomialResult$models)
M1 <- chosen$bestModel
print("Genotypes:")
round(M1$Mu)
print("Clone frequencies:")
M1$P
}

\keyword{ iteration }
\keyword{ documentation }
\keyword{ models }

\name{Clomial.likelihood}
\alias{Clomial.likelihood}
\title{
	Computes the complete data log-likelihood of a Clomial model.
}
\description{
	Computes the expected complete data log-likelihood of a Clomial
	model over all possible values of the hidden variables.
}
\usage{
Clomial.likelihood(Dc, Dt, Mu, P)
}
\arguments{
 \item{Dt}{
	A matrix which contains the counts of the alternative allele
	where rows correspond to the genomic loci, and columns
	correspond to the samples.
	
}
\item{Dc}{
  A matrix which contains the counts of the total number of mapped
  reads where rows correspond to the genomic loci, and columns correspond
  to the samples.
}
\item{Mu}{
  The matrix which models the genotypes, where rows and columns
  correspond to genomic loci and clones, accordingly.
}
\item{P}{
  The matrix of clonal frequency where rows and columns correspond to
  clones and samples, accordingly.
 }
}
\details{
	By assuming that the genomic loci and the samples are
	independent given the model parameters, the computation is
	simplified by first summing over the samples for a locus, and
	then summing over all the loci. This strategy avoids exploring
	the exponentially huge probability space. 
	
}
\value{
A list will be made with the following entries:
	\item{ll }{The expectation of complete log-likelihood over the
	  hidden variables.}
	\item{llS }{A vector of computed log-likelihoods at all loci.}
}
\references{
  Inferring clonal composition from multiple sections of a breast cancer,
  Zare et al., Submitted.
}
\author{
Habil Zare
}
\note{
The likelihood is computed assuming the heterozygosity is 2.
}

\seealso{
\code{\link[Clomial:Clomial-package]{Clomial}},
\code{\link{choose.best}},
\code{\link{compute.bic}}, \code{\link{breastCancer}}
}

\examples{
set.seed(1)
data(breastCancer)
Dc <- breastCancer$Dc
Dt <- breastCancer$Dt
ClomialResult <-Clomial(Dc=Dc,Dt=Dt,maxIt=20,C=4,doParal=FALSE,binomTryNum=1)
model1 <- ClomialResult$models[[1]]
likelihood <- Clomial.likelihood(Dc=Dc, Dt=Dt, Mu=model1$Mu, P=model1$P)$ll
print(likelihood)
}

\keyword{ documentation }
\keyword{ models }

\name{compute.errors}
\alias{compute.errors}
\title{
	Computes the error of a Clomial model.
}
\description{
  Given the true genotype and frequency matrices,
  finds the permutation of genotypes matrix which best matches
  the true genotypes and returns the corresponding errors.}
      
\usage{
compute.errors(Mu, U, P, PTrue)
}
\arguments{
\item{Mu}{
  The matrix which models the genotypes, where rows and columns
  correspond to genomic loci and clones, accordingly.
}
\item{U}{
  The true genotype matrix defined similar to \code{Mu}.
}

\item{P}{
  The matrix of clonal frequency where rows and columns correspond
  to clones and samples, accordingly.
}
\item{PTrue}{
  The true clonal frequency matrix defined similar to \code{P}.
}
}

\details{
  Computing the error is useful for estimating the performance of
  inference on simulated, and for comparing different trained models.
  Genotype and frequency errors are defined as
  the normalized \code{l1}-error in
  reconstructing the genotype, and the clone frequency matrices,
  accordingly, where by normalized \code{l1}-error we mean the sum of absolute
  values of an error matrix divided by the size of the matrix.
}

\value{
  A list will be made with the following entries:
  \item{UError }{The \code{l1}-error of the genotype matrix
    normalized by the size of matrix.}
  \item{discretizedUError }{The \code{l1}-error of the rounded genotype
    matrix,
    i.e. the number of mismatching genotypes, normalized
    by the size of matrix}.
  \item{PErrorAbsolute }{The normalized \code{l1}-error of the clone frequency matrix.}
  \item{PErrorRelative }{Each entry of the error clone frequency
    matrix is normalized by the corresponding entry in
    \code{PTrue}, and then the normalized \code{l1} norm is computed.}
}
\references{
  Inferring clonal composition from multiple sections of a breast cancer,
  Zare et al., Submitted.
}
\author{
Habil Zare
}
\note{
  The use of \code{UError} and \code{PErrorAbsolute} is recommended.
  Computing the error is not feasible for more than 7 clones because
  the number of all possible permutations is factorial in the
  number of clones which grows super fast. Such input will trigger an
  error message.}

\seealso{
\code{\link[Clomial:Clomial-package]{Clomial}}
}
\examples{
set.seed(1)
data(breastCancer)
Dc <- breastCancer$Dc
Dt <- breastCancer$Dt
bics <- c()
ClomialResult <-Clomial(Dc=Dc,Dt=Dt,maxIt=20,C=3,doParal=FALSE,binomTryNum=2)
model1 <- ClomialResult$models[[1]]
model2 <- ClomialResult$models[[2]]
## Comparing 2 trained models:
compute.errors(Mu=model1$Mu,U=model2$Mu,P=model1$P,PTrue=model2$P)
}

\keyword{ documentation }

\name{Clomial.generate.data}
\alias{Clomial.generate.data}
\title{
  Generates simulated data to test performance of Clomial algorithm.
}
\description{
  Data sets are simulated based on binomial distribution using
  random parameters for the model. The accuracy of the EM procedure
  can be estimated by comparing the inferred parameters vs. the known
  ones which were used to generate the data.
}
\usage{
Clomial.generate.data(N, C, S, averageCoverage, mutFraction,
doSample1Normal = FALSE,erroRate=0,doCheckDc=TRUE)
}
\arguments{
  \item{N}{
	The number of genomic loci.
}
  \item{C}{
	The number of clones.
}
  \item{S}{
	The number of samples.
}
  \item{averageCoverage}{
	The average coverage over each loci, each sample.
}
  \item{mutFraction}{
    Should be in range 0-1. Each loci in every sample can be mutated
    with this probability.
}
  \item{doSample1Normal}{
    If TRUE, no contamination with the tumor content is allowed for
    the normal sample. I.e. the first column of the generated \code{P}
    matrix will start with 1, and the rest of its entries will be equal to 0. 
}
  \item{erroRate}{
    The sequencing noise can be simulated by assigning a positive value
    to this parameter, which is the probability of reading a normal
    allele as the alternative allele, and vica versa.
}
  \item{doCheckDc}{
  If TRUE, generating with be repeated until no row of Dc is all zeros to guarantee
  all loci have positive coverage in at least one sample.
}

}
\details{
See the reference below for details.
}

\value{
A list will be made with the following entries:
	\item{Dc }{A matrix of simulated coverage for all loci and samples.}
	\item{Dt }{A matrix of alternative allele counts for all loci
	  and samples.}
	\item{Ptrue }{The true clone frequency matrix used for
	  generating the data.}
	\item{U }{The true genotype matrix used for generating the data.}
	\item{Likelihood }{The log-likelihood of the model with the
	  true parameters.}
	\item{Phi}{The matrix of the second parameters of the binomial
	  distributions; each entry is the probability that a read
	  contains the variant allele at a locus in a sample.}
}
\references{
  Inferring clonal composition from multiple sections of a breast cancer,
  Zare et al., Submitted.
}
\author{
Habil Zare
}

\seealso{
  \code{\link[Clomial:Clomial-package]{Clomial}},
  \code{\link{Clomial.likelihood}}
}
\examples{
set.seed(1)
simulated <- Clomial.generate.data(N=20, C=4, S=10,
  averageCoverage=1000, mutFraction=0.1)
simulated$Dc
}
\keyword{ documentation }
\keyword{ models }

\name{Clomial.iterate}
\alias{Clomial.iterate}
\title{
	Runs EM iterations until convergence of the Clomial model.
}
\description{
  Given the data and the initial values for the model parameters,
  runs EM iterations until convergence of the Clomial model.
}
\usage{
Clomial.iterate(Dt, Dc, Mu, P, maxIt=100, U = NULL, PTrue = NULL,
llCutoff = 10^(-3), computePFunction = compute.P.reparam,
doSilentOptim = TRUE, doTalk = TRUE, doLog = TRUE, debug = FALSE,
noiseReductionRate = 0.01, fliProb=0.05,conservative=TRUE)
}
\arguments{
  \item{maxIt}{
	The maximum number of EM iterations.
}
  \item{Dt}{
	A matrix which contains the counts of the alternative allele
	where rows correspond to the genomic loci, and columns
	correspond to the samples.
}
  \item{Dc}{
	A matrix which contains the counts of the total number of mapped
	reads where rows correspond to the genomic loci, and columns
	correspond to the samples.
}
  \item{Mu}{
    The initial value for the Mu matrix which models the genotypes,
    where rows and columns correspond to genomic loci and clones, accordingly.
}
  \item{P}{
	The initial matrix of clonal frequency where rows and columns
	correspond to clones and samples, accordingly.
}
  \item{U}{
	The true value for \code{Mu}, used for debugging purposes only.
}
  \item{PTrue}{
	The true value for \code{P}, used for debugging purposes only.
}
  \item{llCutoff}{
	EM iterations stops if the relative improvement in the
	log-likelihood is not more than this threshold. 
}
  \item{computePFunction}{
    The function used for updating \code{P}.
    For advanced development use only.
}
  \item{doSilentOptim}{
	If TRUE, the optimization massages will not be reported.
}
  \item{doTalk}{
	If FALSE, the function will be run in silent mode.
}
  \item{doLog}{
    Highly recommended to set to TRUE. Then, the computations will
    be done in log space to avoid numerical issues. 
}
  \item{debug}{
	If TRUE, the debug mode will be turned on.
}
  \item{noiseReductionRate}{
	The noise will be reduce by this rate after each EM iteration.
}
	\item{fliProb}{
	A "flipping probability" used for noise injection which can be
	disabled when \code{fliProb=0}. After the first EM iteration,
	each entry of the matrix \code{Mu} such as \code{m} may change
	to \code{1-m} with this probability. This probability decreases
	on subsequent iterations. 
}
	\item{conservative}{
	Boolean where TRUE means noise will be injected only if
	likelihood is improved after an EM iteration, otherwise the
	original Mu matrix will be used for the next iteration. 
	For expert use only.
}
}
\details{
	Injecting noise can be done by assigning a positive value to
	\code{fliProb}, and can be disabled by \code{fliProb=0}.
	Noise injection is recommended for training models with a high
	number of clones (>4).
}

\value{
A list will be made with the following entries:
	\item{Qs }{The history of matrices containing the posterior
	  \code{Q} values.}
	\item{Ps }{The history of \code{P} matrices.}
	\item{Mus }{The history of \code{Mu} matrices.}
	\item{Mu }{The value of \code{Mu} after convergence.}
	\item{P }{The value of \code{P} after convergence.}
	\item{llCutoff }{The threshold used to decide convergence.}
	\item{LRatio }{The final relative improvement in the log
	  likelihood which lead to convergence.}
	\item{Likelihoods }{The history of log-likelihoods.}
	\item{fliProb }{The final value of \code{fliProb} used for noise
	  injection.}	
	\item{timeTaken }{An object of class ``\link{difftime}'' which
	  reports the total computational time for EM iterations.}
	\item{endTaken }{An object of class ``POSIXct''
	  (see \link{DateTimeClasses}) which reports the time EM
	  iterations finished.}
}
\references{
  Inferring clonal composition from multiple sections of a breast cancer,
  Zare et al., Submitted.
}
\author{
Habil Zare
}

\seealso{
\code{\link[Clomial:Clomial-package]{Clomial}}, 
\code{\link{Clomial}}, \code{\link{breastCancer}}
}

\examples{
set.seed(1)
## Getting data:
data(breastCancer)
Dc <- breastCancer$Dc
Dt <- breastCancer$Dt
freq1 <- Dt/Dc
N <- nrow(Dc)
S <- ncol(Dc)
Cnum <- 4 ## assumed number of clones.
## Random initialization:
random1 <- runif(n=N*(Cnum-1),min=rowMins(freq1)*0.9,max=rowMaxs(freq1)*1.1)
random1[random1>1] <- 1
random1[random1<0] <- 0
Mu <- matrix(random1,N,Cnum-1)
Mu <- cbind( matrix(0,N,1), Mu )
rownames(Mu) <- rownames(Dc)
colnames(Mu) <- paste("C",1:Cnum,sep="")
P <- matrix(runif(Cnum*S),Cnum,S)
rownames(P) <- colnames(Mu)
colnames(P) <- colnames(Dc)
## Normalizing P:
for( t in 1:S ){
	s <- sum(P[,t])
	P[,t] <- P[,t]/s
}##End for.

## Running EM: 
model1 <- Clomial.iterate(Dt=Dt, Dc=Dc, Mu=Mu, P=P)
print("Genotypes:")
round(model1$Mu)
print("Clone frequencies:")
model1$P
}
\keyword{ iteration }
\keyword{ documentation }
\keyword{ models }

\name{choose.best}
\alias{choose.best}
\title{
	Chooses the best trained Clomial model.
}
\description{
	Given the output of Clomial function, the likelihoods of all
	models are compared, and the best model is determined.
}
\usage{
choose.best(models, U = NULL, PTrue = NULL, compareTo = NULL, upto =
"All", doTalk=FALSE)
}
\arguments{
  \item{models}{
	The models trained by \code{Clomial} function.	
}
  \item{U}{
	The optional genotype matrix used for comparison. 
}
  \item{PTrue}{
	The optional clone frequency matrix used for comparison. 
}
  \item{compareTo}{
	The index of the model against which all other models are
	compared. Set to \code{NULL} to disable. 
}
  \item{upto}{
    The models with index less than this value are considered.
    Set to "All" to include every model.
}
	\item{doTalk}{
	If TRUE, information on number of analyzed models is reported.
}
}

\details{
  If \code{compareTo}, \code{U}, and \code{PTrue} are \code{NULL}
  no comparison will be done, and the function runs considerably faster. 
}
\value{
A list will be made with the following entries:
\item{err }{A list with 2 entries; err$P and err$U
  the vectors of clonal frequency errors, and genotype errors, accordingly.}
\item{Li }{A vector of the best obtained log-likelihood for each model.}
\item{bestInd }{The index of the best model in terms of log-likelihood.}
\item{comparison }{If \code{compareTo} is not \code{NULL}, the result
  of comparison with the corresponding model is reported.}
\item{bestModel }{The best model in terms of log-likelihood.}
\item{seconds }{A vector of the time taken,  in seconds, to train each model.}
}
\references{
  Inferring clonal composition from multiple sections of a breast cancer,
  Zare et al., Submitted.
}
\author{
Habil Zare
}
\note{
  When the number of assumed clones, \code{C}, is greater than 6,
  the comparison will be time taking because all possible permutations
  of clones should be considered. The running time will be slowed down
  by \code{C!}.
}

\seealso{
  \code{\link[Clomial:Clomial-package]{Clomial}},
  \code{\link{Clomial.likelihood}}, \code{\link{Clomial.iterate}}
}
\examples{
set.seed(4)
data(breastCancer)
Dc <- breastCancer$Dc
Dt <- breastCancer$Dt
ClomialResult <-Clomial(Dc=Dc,Dt=Dt,maxIt=20,C=4,doParal=FALSE,binomTryNum=5)
chosen <- choose.best(models=ClomialResult$models)
M1 <- chosen$bestModel
print("Genotypes:")
round(M1$Mu)
print("Clone frequencies:")
M1$P
bestInd <- chosen$bestInd
plot(chosen$Li,ylab="Log-likelihood",type="l")
points(x=bestInd,y=chosen$Li[bestInd],col="red",pch=19)
}
\keyword{ documentation }
\keyword{ models }
